<?php
/*------------------------------------------------------------------------
# Copyright (C) 2012-2015 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

 /**
 *Ark inline content Category Context Class
 *
 * @package     Inlinecontent.Contexts
 * @subpackage  Inlinecontent.contexts.ZooCatgory
 */
 
require_once(JPATH_ADMINISTRATOR.'/components/com_zoo/config.php');

class ARKContextsZooCategory extends ARKContextsBase
{

	private $zoo;
	private $category;

	public function __construct($id)
	{
		$this->zoo = App::getInstance('zoo'); 
		$this->table = $this->zoo->table->category;
		$this->category = $this->table->get($id);
		return parent::__construct($id);	
	}	


    public function get($pk = null)
	{
		if($this->id == null)
			return parent::get();	

		return array( 'title'=>$this->category->name,'data'=>$this->category->description);	
	}
	
	
	
	public function triggerContentPlugins($rawText)
	{
		
		$item = new stdclass;
					
		$item->text = '';
		if(isset($rawText))
		{
			$item->text = $rawText;
			$params = array('inline'=>false); //set this so that we don't trigger the inline content plugins
			$dispatcher	= JEventDispatcher::getInstance();
			JPluginHelper::importPlugin('content');
			$dispatcher->trigger('onContentPrepare', array ('com_zoo.application.description', &$item, &$params, 0));
		}	
			
		return array( 'data'=>$item->text);
	}
			
	public function save($data,$pk = null,$type = 'body')
	{
		if($this->id == null)
			return array( 'title'=>'','data'=>'');	
		
		if(isset($data['articletext']))
			$this->category->description = base64_decode($data['articletext']);
		else
		{
			$text = strip_tags($data['title']); 
			$this->category->name = html_entity_decode($text);
		}	
			
		$this->table->save($this->category);
		
		//Let's save version manually as we cannot use JTableObserverContenthistory in this case!
		JTable::addIncludePath(JPATH_PLUGINS.'/system/zooinlineeditable/tables'); 
		
		$item = JTable::getInstance('category','ZOOTable');
		
		$item->id = $this->category->id;
		$item->name = $this->category->name;
		$item->description = $this->category->description;
		
		$typeAlias = 'com_zoo.category';	
		$contenthistoryHelper = new JHelperContenthistory($typeAlias);			
		$contenthistoryHelper->store($item);
		
		//We need to process data as we are sending it back to the client
		
		$iten = new stdclass;
		$item->text = $this->application->description;
		
		//let's detect if any plugin tags are being used 
		//if so let's inform the system to warn the user
		$message = $this->detectPluginTags($item->text);	

		$params =  array('inline'=>false);
		$dispatcher	= JEventDispatcher::getInstance();
		JPluginHelper::importPlugin('content');
		$dispatcher->trigger('onContentPrepare', array ('com_zoo.category.description', &$item, &$params, 0));
												
		return array( 'title'=>$this->category->name,'data'=>$item->text,'message'=>$message);	
	}
	
	public function version($versionId,$type)
	{
		$historyTable = JTable::getInstance('Contenthistory');
		$historyTable->load($versionId);
		$rowArray = JArrayHelper::fromObject(json_decode($historyTable->version_data));
		
		JTable::addIncludePath(JPATH_PLUGINS.'/system/zooinlineeditable/tables'); 	
		$item = JTable::getInstance('category','ZOOTable');

		$item->bind($rowArray);	
		if($type == 'title')
		{
			return array( 'data'=>$item->name);
		}
		$text = '';
		
		$text = $item->description;
	
		return array( 'data'=>$text);
		
	}
}