<?php
/*------------------------------------------------------------------------
# Copyright (C) 2012-2015 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 * Ark Inline content editing Plugin
 *
 * @package     extensions.ARKExtensions
 * @subpackage  extensions.ARKExtensionsBase
 */
class ARKExtensionsZOO extends  ARKExtensionsBase
{

	
	protected $application;
	
	protected $zoo;
 	
	public  function __construct($context, $item, $params)
	{
		//call parent construtor
		parent::__construct($context, $item, $params);
		 //set allowable context array for inline editing
		$this->inline_allowed_contexts = array ('com_zoo.application.description','com_zoo.category.description');
		 
		if($this->app->input->get('arkoption') != 'com_zoo')   
			$this->skipProccessing = true; 
		
		$this->zoo = App::getInstance('zoo');
		$this->application = $this->zoo->zoo->getApplication();
		$this->application_id = $this->application->id;
    }	
	
	
	public function prepare()
	{
	    
		if($this->skipProccessing)
			return;
		
		//Set Data Item Type
		$this->type = str_replace(array($this->app->input->get('option').'.','.description'),'',$this->context);
		
		if($this->type == 'category')
		{
			$this->id = $this->app->input->get('category_id', $this->app->getParams()->get('category'));
		}
		else
		{
			$this->id = $this->application_id;
			$this->type ='frontpage';
		}
	
		
		//Set Asset name 
		
		$asset = 'com_zoo.application.' . $this->id;

		$user = JFactory::getUser();		
		//can user edit item if not then bail
		if (!($user->authorise('core.edit', $asset))) 
		{
			return false;
		}	

		//need to override base class here for following check for categories
		/*filter article to see if it is being used to load a module if so skip it
		[widgetkit]
		{loadmodule}
		{loadposition}
		{module}
		{modulepos}
		{modulepos}
		{component}
		{article(s)}
		*/

		$test = preg_match('/\{(?:loadmodule|loadposition|module|modulepos|component|articles?)\s+(.*?)\}/i',$text);
	
		if(!$test)
			$test = preg_match('/\[widgetkit\s+(.*?)\]/i',$article->text);
		
		if($test)
		{	
			return;
		}
		
		if($this->type == 'category')
		{
			$category = $this->zoo->table->category->get($this->id);
			$category->name = '{div class=__ARKQUOTE__editable__ARKQUOTE__ data-id=__ARKQUOTE__'.$this->id.'__ARKQUOTE__ data-context=__ARKQUOTE__'.$this->dataContext.'__ARKQUOTE__ data-type=__ARKQUOTE__title__ARKQUOTE__ data-itemtype=__ARKQUOTE__'.$this->type.'__ARKQUOTE__ contenteditable=__ARKQUOTE__true__ARKQUOTE__ style=__ARKQUOTE__display:inline;__ARKQUOTE__}'.$category->name.'{/div}'; 
		}
		else
		{
			$this->application->name = '{div class=__ARKQUOTE__editable__ARKQUOTE__ data-id=__ARKQUOTE__'.$this->id.'__ARKQUOTE__ data-context=__ARKQUOTE__'.$this->dataContext.'__ARKQUOTE__ data-type=__ARKQUOTE__title__ARKQUOTE__ data-itemtype=__ARKQUOTE__'.$this->type.'__ARKQUOTE__ contenteditable=__ARKQUOTE__true__ARKQUOTE__ style=__ARKQUOTE__display:inline;__ARKQUOTE__}'.$this->application->name.'{/div}'; 
		}
		return parent::prepare();	 
	}	
	
		
	public function display()
	{
           
    }   
}